pipeline {
  agent any
	
  triggers {
    pollSCM('* * * * *')
  }
	
  stages {
    stage("Compile") {
      steps {
        sh "./gradlew compileJava"
      }
    }
	  
    stage("Unit test") {
      steps {
        sh "./gradlew test"
      }
    }
	
    stage("Code coverage") {
      steps {
        sh "./gradlew jacocoTestReport"
        publishHTML (target: [
               reportDir: 'build/reports/jacoco/test/html',
               reportFiles: 'index.html',
               reportName: "JaCoCo Report" ])
        sh "./gradlew jacocoTestCoverageVerification"
      }
    }

    stage("Static code analysis") {
      steps {
        sh "./gradlew checkstyleMain"
        publishHTML (target: [
               reportDir: 'build/reports/checkstyle/',
               reportFiles: 'main.html',
               reportName: "Checkstyle Report" ])
      }
    }

    stage("Build") {
      steps {
        sh "./gradlew build"
      }
    }

    stage("Docker build") {
      steps {
        sh "docker build -t tributasoft/prueba_web_2:${BUILD_TIMESTAMP} ."
      }
    }

    stage("Docker login") {
      steps {
        sh "docker login --username tributasoft --password tributa2016..#"
      }
    }

    stage("Docker push") {
      steps {
        sh "docker push tributasoft/prueba_web_2:${BUILD_TIMESTAMP}"
        //sleep 60
      }
    }

    //stage("Deploy to staging") {
    //  steps {
    //    sh "docker run -d --rm -p 8765:8080 --name prueba_web_2 tributasoft/prueba_web_2:${BUILD_TIMESTAMP}"
    //    sleep 10
    //  }
    //}

    //stage(""Acceptance test"") {
    //  steps {
    //    sleep 60
    //    sh "./acceptance_test2.sh"
    //  }
    //}
  }
  //post { always { sh "docker stop prueba_web_2" } }

}
